package JCAT;
import java.awt.*;


public class DirBox extends Dialog {
  
    private String j2sDir  = System.getProperty("d1");
    private String spinDir = System.getProperty("d2");
    private String ccDir   = System.getProperty("d3");
    private String timeDir = System.getProperty("d4");
    private String bashDir = System.getProperty("d5");
    private String jadDir  = System.getProperty("d6");

    private String tmpDir  = "Jcatmp";
    private String model   = "a.spin";

    public String getJ2SDir()
    {
	return j2sDir;
    }

    public String getSpinDir()
    {
	return spinDir;
    }

    public String getCCDir()
    {
	return ccDir;
    }

    public String getTimeDir()
    {
	return timeDir;
    }

    public String getBashDir()
    {
	return bashDir;
    }

    public String getJadDir()
    {
	return jadDir;
    }

    public String getTmpDir()
    {
	return tmpDir;
    }

    public String getModel()
    {
	return model;
    }


    public DirBox(Frame parent) {

	super(parent, "Directories", true);

	setLayout(null);
	addNotify();
	resize(insets().left + insets().right + 378, insets().top + insets().bottom + 307);
	labelSpinDir=new Label("SPIN directory:");
	labelSpinDir.setFont(new Font("Dialog",Font.BOLD,8));
	add(labelSpinDir);
	labelSpinDir.reshape(insets().left + 9,insets().top + 8,124,25);
	labelJ2SDir=new Label("Java2Spin directory:");
	labelJ2SDir.setFont(new Font("Dialog",Font.BOLD,8));
	add(labelJ2SDir);
	labelJ2SDir.reshape(insets().left + 7,insets().top + 45,126,26);
	editSpinDir=new TextField(spinDir, 26);
	editSpinDir.setFont(new Font("Dialog",Font.BOLD,8));
	add(editSpinDir);
	editSpinDir.reshape(insets().left + 149,insets().top + 7,217,27);
	editJ2SDir=new TextField(j2sDir, 26);
	editJ2SDir.setFont(new Font("Dialog",Font.BOLD,8));
	add(editJ2SDir);
	editJ2SDir.reshape(insets().left + 147,insets().top + 46,217,26);
	OKButton1=new Button("Okay");
	add(OKButton1);
	OKButton1.reshape(insets().left + 175,insets().top + 240,77,33);
	cancelButton=new Button("Cancel");
	add(cancelButton);
	cancelButton.reshape(insets().left + 280,insets().top + 240,77,33);
	labelCCDir=new Label("CC directory:");
	labelCCDir.setFont(new Font("Dialog",Font.BOLD,8));
	add(labelCCDir);
	labelCCDir.reshape(insets().left + 7,insets().top + 84,126,26);
	editCCDir=new TextField(ccDir, 26);
	editCCDir.setFont(new Font("Dialog",Font.BOLD,8));
	add(editCCDir);
	editCCDir.reshape(insets().left + 147,insets().top + 84,217,26);
	labelTimeDir=new Label("TIME directory:");
	labelTimeDir.setFont(new Font("Dialog",Font.BOLD,8));
	add(labelTimeDir);
	labelTimeDir.reshape(insets().left + 7,insets().top + 123,126,26);
	editTimeDir=new TextField(timeDir, 26);
	editTimeDir.setFont(new Font("Dialog",Font.BOLD,8));
	add(editTimeDir);
	editTimeDir.reshape(insets().left + 147,insets().top + 123,217,26);
	labelBashDir=new Label("BASH directory:");
	labelBashDir.setFont(new Font("Dialog",Font.BOLD,8));
	add(labelBashDir);
	labelBashDir.reshape(insets().left + 7,insets().top + 162,126,26);
	editBashDir=new TextField(bashDir, 26);
	editBashDir.setFont(new Font("Dialog",Font.BOLD,8));
	add(editBashDir);
	editBashDir.reshape(insets().left + 147,insets().top + 162,217,26);
	labelJadDir=new Label("JAD directory:");
	labelJadDir.setFont(new Font("Dialog",Font.BOLD,8));
	add(labelJadDir);
	labelJadDir.reshape(insets().left + 7,insets().top + 201,126,26);
	editJadDir=new TextField(jadDir, 26);
	editJadDir.setFont(new Font("Dialog",Font.BOLD,8));
	add(editJadDir);
	editJadDir.reshape(insets().left + 147,insets().top + 201,217,26);
	//}}

	setResizable(false);
    }

    public synchronized void show() {
	Rectangle bounds = getParent().bounds();
	Rectangle abounds = bounds();
    
	move(bounds.x + (bounds.width - abounds.width)/ 2,
	     bounds.y + (bounds.height - abounds.height)/2);
    
	super.show();
    }
  
    public synchronized void wakeUp() {
	notify();
    }

    public boolean handleEvent(Event event) {
	if (event.id == Event.ACTION_EVENT && event.target == OKButton1) {
	    clickedOKButton1();
	    return true;
	}
	else
	    if (event.id == Event.ACTION_EVENT && event.target == cancelButton) {
		clickedCancelButton();
		return true;
	    }
	    else	
		if (event.id == Event.WINDOW_DESTROY) {
		    hide();
		    return true;
		}
    	return super.handleEvent(event);
    }
  
    //{{DECLARE_CONTROLS
    Label labelSpinDir;
    Label labelJ2SDir;
    TextField editSpinDir;
    TextField editJ2SDir;
    Button OKButton1;
    Button cancelButton;
    Label labelCCDir;
    TextField editCCDir;
    Label labelTimeDir;
    TextField editTimeDir;
    Label labelBashDir;
    TextField editBashDir;
    Label labelJadDir;
    TextField editJadDir;
    //}}


    public void clickedCancelButton() {
	hide();
    }


    public void clickedOKButton1() {
	j2sDir  = editJ2SDir.getText();
	spinDir = editSpinDir.getText();
	ccDir   = editCCDir.getText();
	timeDir = editTimeDir.getText();
	bashDir = editBashDir.getText();
	jadDir  = editJadDir.getText();
	hide();
    }
}


