package JCAT;

import java.io.*;
import java.util.*;

//
// Hacked class usefull to avoid the buggy java.util.StringTokenizer :-(
//

class Nltok
{
    String s_;
    int next;


    public Nltok(String s)
    {
	s_ = s;
	next = 0;
    }


    public String nextLine()
    {
	int index;
	String s;

	if (next < 0)
	    return null;

	index = s_.indexOf("\n", next);

	if (index < 0) {
	    s = s_.substring(next);
	    next = -1;
	}
	else {
	    s = s_.substring(next, index);
	    next = index + 1;
	}

	return s;
    }
}


class FileLoader
{
    private Vector lines;
    private FileInputStream stream;
    private String path;


    public FileLoader(String p) throws IOException
    {
	path = p;
	stream = new FileInputStream(path);
	lines = new Vector();
    }


    public String getPath()
    {
	return path;
    }


    public void load() throws IOException
    {
	byte block [] = new byte [1024];
	int len;
	String last = "";
	String s;
	Nltok tok;

	while ((len = stream.read(block, 0, 1024)) != -1) {
	    tok = new Nltok(last + new String(block, 0, 0, len));
	    last = tok.nextLine();

	    while ((s = tok.nextLine()) != null) {
		lines.addElement(last);
		last = s;
	    }
	}
    }


    public int getSize()
    {
	return lines.size();
    }


    public String lineAt(int index)
    {
	return (String)lines.elementAt(index);
    }
}

