package JCAT;

import java.io.*;
%%

%{
  private RelationLine line;
  private Relation rel;

  private String cutTo(String del)
    {
      String s = yytext();
      int index = s.indexOf(del);
      return s.substring(0, index);
    }

  public Relation getRelation()
    {
      return rel;
    }
%}

%init{
  rel = new Relation();
%init}

%integer
%class ProLex

%line

%state FILE
%state LINE

%%

<YYINITIAL>"/* line: "                {
                                      line = new RelationLine(yyline + 1);
				      yybegin(FILE);
                                      }

<FILE>[^" "]+" "                      {
                                      line.setJavaFile(cutTo(" "));
                                      yybegin(LINE);
                                      }

<LINE>[0-9]+" */"                     {
                                      line.setJavaLine(cutTo(" "));
				      rel.addLine(line);
				      yybegin(YYINITIAL);	
                                      }

<YYINITIAL>.|\n                       {
                                      }

