package JCAT;

import java.awt.*;

class SpinOut
{
    private String version;

    private boolean endState = false;
    private boolean assertionViolated = false;
    private boolean outOfMemory = false;

    private Integer stateVector;
    private Integer depthReached;
    private Integer errors;

    private Integer storedStates;
    private Integer matchedStates;
    private Integer transitions;
    private Integer atomicSteps;

    public void setVersion(String ver)
    {
	version = new String(ver);
    }

    public String getVersion()
    {
	return version;
    }

    public void setVector(String dim)
    {
	stateVector = new Integer(dim);
    }

    public Integer getVector()
    {
	return stateVector;
    }

    public void setDepth(String dim)
    {
	depthReached = new Integer(dim);
    }

    public Integer getDepth()
    {
	return depthReached;
    }

    public void setErrors(String dim)
    {
	errors = new Integer(dim);
    }

    public Integer getErrors()
    {
	return errors;
    }

    public void setStored(String dim)
    {
	storedStates = new Integer(dim);
    }

    public Integer getStored()
    {
	return storedStates;
    }

    public void setMatched(String dim)
    {
	matchedStates = new Integer(dim);
    }

    public Integer getMatched()
    {
	return matchedStates;
    }

    public void setTransitions(String dim)
    {
	transitions = new Integer(dim);
    }

    public Integer getTransitions()
    {
	return transitions;
    }

    public void setAtomic(String dim)
    {
	atomicSteps = new Integer(dim);
    }

    public Integer getAtomic()
    {
	return atomicSteps;
    }

    public void setEndState()
    {
	endState = true;
    }

    public boolean getEndState()
    {
	return endState;
    }

    public void setAssertion()
    {
	assertionViolated = true;
    }

    public boolean getAssertion()
    {
	return assertionViolated;
    }

    public void setOutOfMemory()
    {
	outOfMemory = true;
    }

    public boolean outOfMemory()
    {
	return outOfMemory;
    }

    public void print(TextArea t)
    {
	t.appendText("(Spin " + version + ")\n");
	t.appendText("State vector: " + stateVector + " bytes\n");
	t.appendText("Depth reached: " + depthReached + "\n");
	t.appendText("Stored states: " + storedStates + "\n");
	t.appendText("Matched states: " + matchedStates + "\n");
	t.appendText("Transitions: " + transitions + "\n");
	t.appendText("Atomic steps: " + atomicSteps + "\n");
    }
}

